unit im_contrastFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GlUtils,{strtofloatdef}
  StdCtrls, Buttons, ExtCtrls,im_childwin, ComCtrls,
  gr32,im_basic,math;

type
  TContrastCTRLForm = class(TForm)
    Edit2: TEdit;
    Edit1: TEdit;
    Label3: TLabel;
    Label22: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Edit3: TEdit;
    TrackBar3: TTrackBar;
    HelpBtn: TSpeedButton;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure updateimage(Tempbitmap:Tbitmap32);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ApplyUpdateImage;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    FOrgWidth:Integer;
    FOrgHeight:Integer;
    FWidth:Integer;
    FHeight:Integer;
  src:tbitmap32;
  dst:tbitmap32;
  srcrect,dstrect:trect;
  end;

var
  ContrastCTRLForm: TContrastCTRLForm;
  dochange:boolean;
  contrast,brightness,gamma:real;
implementation

uses im_D5,im_MainFrm;

{$R *.dfm}

procedure TContrastCTRLForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ContrastCtrlFormX := ContrastCtrlForm.left;
  ContrastCtrlFormY:= ContrastCtrlForm.top;
end;
procedure TContrastCtrlForm.FormCreate(Sender: TObject);
begin
  left := ContrastCtrlFormX;
  top := ContrastCtrlFormY;
  dst:=TBitmap32.Create;
  src:=TBitmap32.Create;
end;

procedure TContrastCTRLForm.FormShow(Sender: TObject);
begin
      src.Assign(dst);
      Contrast:=0;
      Brightness:=0;
      edit1.text:='0';
      edit2.text:='0';
      trackbar1.position:=0;
      trackbar2.position:=0;
      trackbar3.position:=100;
end;

procedure TContrastCTRLForm.Edit1KeyPress(Sender: TObject; var Key: Char);
{var	v,b,g:integer;}
begin
//	if not dochange then exit;
if key=chr(13) then
 begin
 trackbar1.position:=ensurerangeiiii(trackbar1.Min,trackbar1.Max,strtointdef(edit1.text,0));
 trackbar2.position:=ensurerangeiiii(trackbar2.Min,trackbar2.Max,strtointdef(edit2.text,0));
 trackbar3.position:=ensurerangeiiii(trackbar3.Min,trackbar3.Max,round(strtofloatdef(edit3.text,0)*100));
 trackbar1change(self);
 end;

end;

procedure TContrastCTRLForm.updateimage(tempbitmap:tbitmap32);
begin
      contrast:=(Trackbar1.position);
      brightness:=(Trackbar2.position);
      im_basic.contrast(tempbitmap,contrast/100);
      im_basic.brightness(tempbitmap,brightness/100);
      im_basic.gamma(tempbitmap,gamma/100);
      mainform.updatehistogram;
end;

procedure TContrastCtrlForm.ApplyUpdateImage;
begin
  dst.Assign(src);
  updateimage(dst);
  with MainForm.ActiveMDIChild as TMdiChild do begin
   if selectionactive=true then
   imageview1.Bitmap.Draw(srcrect,dstrect,dst)
   else
   imageview1.Bitmap.Assign(dst);
   Imageview1.Repaint;
  end;
end;


procedure TContrastCTRLForm.Button1Click(Sender: TObject);
begin
//apply
   updateimage(dst);
end;

procedure TContrastCTRLForm.TrackBar1Change(Sender: TObject);
begin
 //	if not dochange then exit;
	if (Contrast<>trackbar1.position) or (Brightness<>trackbar2.position) or
    (gamma<>trackbar3.Position) then begin
   	Contrast:=trackbar1.position;
      edit1.text:=inttostr(round(Contrast));
      Brightness:=trackbar2.position;
      edit2.text:=inttostr(round(Brightness));
      Gamma:=trackbar3.position;
      edit3.text:=floattostr(Gamma/100);

//  MainForm.UpdateImage:=true;
  Applyupdateimage;
  end;
end;






procedure TContrastCTRLForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(2000);
end;

end.
